// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: service.proto

package ec.edu.uees.msfacturasrelacional.communication.grpc.generated;

/**
 * Protobuf type {@code Item}
 */
public final class Item extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:Item)
    ItemOrBuilder {
private static final long serialVersionUID = 0L;
  // Use Item.newBuilder() to construct.
  private Item(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private Item() {
    producto_ = "";
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new Item();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private Item(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 8: {

            cantidad_ = input.readInt32();
            break;
          }
          case 18: {
            java.lang.String s = input.readStringRequireUtf8();

            producto_ = s;
            break;
          }
          case 25: {

            valorPorProducto_ = input.readDouble();
            break;
          }
          case 33: {

            valorUnitario_ = input.readDouble();
            break;
          }
          default: {
            if (!parseUnknownField(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Item_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Item_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.class, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder.class);
  }

  public static final int CANTIDAD_FIELD_NUMBER = 1;
  private int cantidad_;
  /**
   * <code>int32 cantidad = 1;</code>
   * @return The cantidad.
   */
  @java.lang.Override
  public int getCantidad() {
    return cantidad_;
  }

  public static final int PRODUCTO_FIELD_NUMBER = 2;
  private volatile java.lang.Object producto_;
  /**
   * <code>string producto = 2;</code>
   * @return The producto.
   */
  @java.lang.Override
  public java.lang.String getProducto() {
    java.lang.Object ref = producto_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      producto_ = s;
      return s;
    }
  }
  /**
   * <code>string producto = 2;</code>
   * @return The bytes for producto.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getProductoBytes() {
    java.lang.Object ref = producto_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      producto_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int VALORPORPRODUCTO_FIELD_NUMBER = 3;
  private double valorPorProducto_;
  /**
   * <code>double valorPorProducto = 3;</code>
   * @return The valorPorProducto.
   */
  @java.lang.Override
  public double getValorPorProducto() {
    return valorPorProducto_;
  }

  public static final int VALORUNITARIO_FIELD_NUMBER = 4;
  private double valorUnitario_;
  /**
   * <code>double valorUnitario = 4;</code>
   * @return The valorUnitario.
   */
  @java.lang.Override
  public double getValorUnitario() {
    return valorUnitario_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (cantidad_ != 0) {
      output.writeInt32(1, cantidad_);
    }
    if (!getProductoBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 2, producto_);
    }
    if (valorPorProducto_ != 0D) {
      output.writeDouble(3, valorPorProducto_);
    }
    if (valorUnitario_ != 0D) {
      output.writeDouble(4, valorUnitario_);
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (cantidad_ != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeInt32Size(1, cantidad_);
    }
    if (!getProductoBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, producto_);
    }
    if (valorPorProducto_ != 0D) {
      size += com.google.protobuf.CodedOutputStream
        .computeDoubleSize(3, valorPorProducto_);
    }
    if (valorUnitario_ != 0D) {
      size += com.google.protobuf.CodedOutputStream
        .computeDoubleSize(4, valorUnitario_);
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item)) {
      return super.equals(obj);
    }
    ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item other = (ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item) obj;

    if (getCantidad()
        != other.getCantidad()) return false;
    if (!getProducto()
        .equals(other.getProducto())) return false;
    if (java.lang.Double.doubleToLongBits(getValorPorProducto())
        != java.lang.Double.doubleToLongBits(
            other.getValorPorProducto())) return false;
    if (java.lang.Double.doubleToLongBits(getValorUnitario())
        != java.lang.Double.doubleToLongBits(
            other.getValorUnitario())) return false;
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + CANTIDAD_FIELD_NUMBER;
    hash = (53 * hash) + getCantidad();
    hash = (37 * hash) + PRODUCTO_FIELD_NUMBER;
    hash = (53 * hash) + getProducto().hashCode();
    hash = (37 * hash) + VALORPORPRODUCTO_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        java.lang.Double.doubleToLongBits(getValorPorProducto()));
    hash = (37 * hash) + VALORUNITARIO_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        java.lang.Double.doubleToLongBits(getValorUnitario()));
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code Item}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:Item)
      ec.edu.uees.msfacturasrelacional.communication.grpc.generated.ItemOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Item_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Item_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.class, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder.class);
    }

    // Construct using ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
      }
    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      cantidad_ = 0;

      producto_ = "";

      valorPorProducto_ = 0D;

      valorUnitario_ = 0D;

      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Item_descriptor;
    }

    @java.lang.Override
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item getDefaultInstanceForType() {
      return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.getDefaultInstance();
    }

    @java.lang.Override
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item build() {
      ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item buildPartial() {
      ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item result = new ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item(this);
      result.cantidad_ = cantidad_;
      result.producto_ = producto_;
      result.valorPorProducto_ = valorPorProducto_;
      result.valorUnitario_ = valorUnitario_;
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }
    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return super.setField(field, value);
    }
    @java.lang.Override
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }
    @java.lang.Override
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }
    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }
    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }
    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item) {
        return mergeFrom((ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item other) {
      if (other == ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.getDefaultInstance()) return this;
      if (other.getCantidad() != 0) {
        setCantidad(other.getCantidad());
      }
      if (!other.getProducto().isEmpty()) {
        producto_ = other.producto_;
        onChanged();
      }
      if (other.getValorPorProducto() != 0D) {
        setValorPorProducto(other.getValorPorProducto());
      }
      if (other.getValorUnitario() != 0D) {
        setValorUnitario(other.getValorUnitario());
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private int cantidad_ ;
    /**
     * <code>int32 cantidad = 1;</code>
     * @return The cantidad.
     */
    @java.lang.Override
    public int getCantidad() {
      return cantidad_;
    }
    /**
     * <code>int32 cantidad = 1;</code>
     * @param value The cantidad to set.
     * @return This builder for chaining.
     */
    public Builder setCantidad(int value) {
      
      cantidad_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>int32 cantidad = 1;</code>
     * @return This builder for chaining.
     */
    public Builder clearCantidad() {
      
      cantidad_ = 0;
      onChanged();
      return this;
    }

    private java.lang.Object producto_ = "";
    /**
     * <code>string producto = 2;</code>
     * @return The producto.
     */
    public java.lang.String getProducto() {
      java.lang.Object ref = producto_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        producto_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string producto = 2;</code>
     * @return The bytes for producto.
     */
    public com.google.protobuf.ByteString
        getProductoBytes() {
      java.lang.Object ref = producto_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        producto_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string producto = 2;</code>
     * @param value The producto to set.
     * @return This builder for chaining.
     */
    public Builder setProducto(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      producto_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string producto = 2;</code>
     * @return This builder for chaining.
     */
    public Builder clearProducto() {
      
      producto_ = getDefaultInstance().getProducto();
      onChanged();
      return this;
    }
    /**
     * <code>string producto = 2;</code>
     * @param value The bytes for producto to set.
     * @return This builder for chaining.
     */
    public Builder setProductoBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      producto_ = value;
      onChanged();
      return this;
    }

    private double valorPorProducto_ ;
    /**
     * <code>double valorPorProducto = 3;</code>
     * @return The valorPorProducto.
     */
    @java.lang.Override
    public double getValorPorProducto() {
      return valorPorProducto_;
    }
    /**
     * <code>double valorPorProducto = 3;</code>
     * @param value The valorPorProducto to set.
     * @return This builder for chaining.
     */
    public Builder setValorPorProducto(double value) {
      
      valorPorProducto_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>double valorPorProducto = 3;</code>
     * @return This builder for chaining.
     */
    public Builder clearValorPorProducto() {
      
      valorPorProducto_ = 0D;
      onChanged();
      return this;
    }

    private double valorUnitario_ ;
    /**
     * <code>double valorUnitario = 4;</code>
     * @return The valorUnitario.
     */
    @java.lang.Override
    public double getValorUnitario() {
      return valorUnitario_;
    }
    /**
     * <code>double valorUnitario = 4;</code>
     * @param value The valorUnitario to set.
     * @return This builder for chaining.
     */
    public Builder setValorUnitario(double value) {
      
      valorUnitario_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>double valorUnitario = 4;</code>
     * @return This builder for chaining.
     */
    public Builder clearValorUnitario() {
      
      valorUnitario_ = 0D;
      onChanged();
      return this;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:Item)
  }

  // @@protoc_insertion_point(class_scope:Item)
  private static final ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item();
  }

  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<Item>
      PARSER = new com.google.protobuf.AbstractParser<Item>() {
    @java.lang.Override
    public Item parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new Item(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<Item> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<Item> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

